# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define version_maj 3
%define version_min 1
%define version_rev 2
%define version_tag SP1
%define rpm_release_tag %{nil}
%define release_tag %{nil}
%define version_full %{version_maj}.%{version_min}.%{version_rev}.%{version_tag}
%define release_full %{version_maj}.%{version_min}.%{version_rev}.%{version_tag}%{release_tag}

%define repodir %{_javadir}/repository.jboss.com/jboss/jbossws/%{release_full}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

Name:           jbossws
Version:        %{version_maj}.%{version_min}.%{version_rev}
Release:        1.%{version_tag}%{rpm_release_tag}.4%{?dist}
Epoch:          1
Summary:        JBoss Web Services
License:        LGPLv2+
Group:          Development/Java
URL:            http://labs.jboss.com/jbossws/
# svn -q export http://anonsvn.jboss.org/repos/jbossws/stack/native/tags/jbossws-native-3.1.2.SP1 jbossws-native-3.1.2.SP1 && tar cjf jbossws-3.1.2.SP1-src.tar.bz2 jbossws-native-3.1.2.SP1
Source0:        jbossws-%{version_full}-src.tar.bz2
Source1:        jbossws-component-info.xml
Source2:        jbossws-jpp-depmap.xml
Patch0:         jbossws-pom.xml.patch
Patch1:         jbossws-xmlsec.patch
Patch2:         jbossws-JBPAPP-2825.patch
Patch3:         jbossws-mime-utils.patch
Patch4:         jbossws-pom.xml-2.patch
# FIXME: (dwalluck): check the BuildRequires
%if 0
apache-scout:scout
commons-logging:commons-logging
com.sun.xml.bind:jaxb-impl
com.sun.xml.bind:jaxb-xjc
com.sun.xml.fastinfoset:FastInfoset
com.sun.xml.ws:jaxws-rt
com.sun.xml.ws:jaxws-tools
javassist:javassist
javax.activation:activation
javax.annotation:jsr250-api
javax.ejb:ejb-api
javax.jms:jms
javax.mail:mail
javax.servlet:servlet-api
javax.xml.bind:jaxb-api
jboss.common:jboss-common
jboss.jaxbintros:jboss-jaxb-intros
juddi:juddi
org.apache:xmlsec
org.codehaus.jettison:jettison
org.codehaus.woodstox:wstx-lgpl
org.jboss.jaxr:juddi-service
org.jboss.logging:jboss-logging-log4j
org.jboss.remoting:jboss-remoting
org.jboss.ws:jbossws-common
org.jboss.ws:jbossws-framework
org.jboss.ws:jbossws-spi
wsdl4j:wsdl4j
xalan:xalan
xerces:xercesImpl
%endif
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       glassfish-jaf
Requires:       glassfish-jaxb
Requires:       glassfish-jaxws
Requires:       glassfish-javamail
Requires:       jboss-common-core
Requires:       jboss-remoting
Requires:       jbossws-common >= 0:1.1.0
Requires:       jbossws-framework >= 0:3.1.2
Requires:       jbossws-spi >= 0:1.1.2-1.SP1.1
Requires:       jbossxb2
Requires:       jpackage-utils
Requires:       jbossweb
Requires:       wsdl4j
Requires:       wstx
Requires:       xalan-j2
Requires:       xerces-j2
Requires:       xml-security
BuildRequires:  codehaus-stax11-api >= 0:1.1.2
BuildRequires:  glassfish-jaxb >= 0:2.1.9
BuildRequires:  glassfish-jaxws >= 0:2.1.3
BuildRequires:  glassfish-javamail
BuildRequires:  jaxbintros >= 0:1.0.0
BuildRequires:  jettison >= 0:1.0
BuildRequires:  jakarta-commons-logging >= 0:1.1.1
BuildRequires:  javassist >= 0:3.6.0
BuildRequires:  jboss5-libs >= 0:5.1.0
BuildRequires:  jboss-jaxr >= 0:1.2.1
BuildRequires:  jboss-parent >= 0:4.0
BuildRequires:  jboss-javaee-poms >= 0:5.0.0
BuildRequires:  jboss-ejb-3.0-api >= 0:5.0.0
BuildRequires:  jboss-jms-1.1-api >= 0:5.0.0
BuildRequires:  jboss-microcontainer2 >= 0:2.0.2
BuildRequires:  jboss-common-core >= 0:2.2.14
BuildRequires:  jboss-remoting >= 0:2.5.1
BuildRequires:  jboss-security-spi >= 0:2.0.3
BuildRequires:  jbosssx2 >= 0:2.0.3
BuildRequires:  jbossws 
BuildRequires:  jbossws-parent >= 0:1.0.2
BuildRequires:  jbossws-common >= 0:1.1.0
BuildRequires:  jbossws-framework >= 0:3.1.2
BuildRequires:  jbossws-spi >= 0:1.1.2-1.SP1.1
BuildRequires:  jbossxb2 >= 0:2.0.0
BuildRequires:  jpackage-utils
BuildRequires:  jbossweb >= 0:2.1.3
BuildRequires:  sun-fi >= 0:1.2.7
BuildRequires:  tjws >= 0:1.3.3
BuildRequires:  wsdl4j >= 0:1.6.2
BuildRequires:  wstx >= 0:3.2.6
BuildRequires:  xalan-j2 >= 0:2.7.1
BuildRequires:  xerces-j2 >= 0:2.8.1
BuildRequires:  xml-security >= 0:1.4.2
BuildRequires:  maven2
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  mojo-maven2-plugin-buildnumber
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBossWS an implementation of J2EE Web Services

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n jbossws-native-%{version_full}
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -p0 -b .sav2
%patch3 -p0 -b .sav3
%patch4 -p0 -b .sav4

%build
export JBOSS_HOME=%{_datadir}/jbossas
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL
mkdir -p output/reposave

%{_bindir}/mvn-jpp install:install-file -DgroupId=org.jboss.ws -DartifactId=jbossws-framework -Dversion=%{version_full} -Dclassifier=testsuite -Dpackaging=zip -Dfile=%{_javadir}/jbossws-framework-testsuite.zip -Dmaven.repo.local=${MAVEN_REPO_LOCAL}

%{_bindir}/mvn-jpp \
        -e \
        -Djava.jdk15.home=%{java_home} \
        -Djboss.repository=$(pwd)/repository \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=false \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Djboss.local.repository=output/reposave \
        install

%install
rm -rf %{buildroot}

# Install to javadir
install -dm 755 %{buildroot}%{_javadir}/%{name}
cp -p modules/jaxws/target/jbossws-native-jaxws-%{version_full}-sources.jar %{buildroot}%{_javadir}/%{name}
cp -p modules/jaxws/target/jbossws-native-jaxws-%{version_full}.jar %{buildroot}%{_javadir}/%{name}
cp -p modules/saaj/target/jbossws-native-saaj-%{version_full}-sources.jar %{buildroot}%{_javadir}/%{name}
cp -p modules/saaj/target/jbossws-native-saaj-%{version_full}.jar %{buildroot}%{_javadir}/%{name}
cp -p modules/core/target/jbossws-native-core-%{version_full}.jar %{buildroot}%{_javadir}/%{name}
cp -p modules/core/target/jbossws-native-core-%{version_full}-sources.jar %{buildroot}%{_javadir}/%{name}
cp -p modules/jaxrpc/target/jbossws-native-jaxrpc-%{version_full}-sources.jar %{buildroot}%{_javadir}/%{name}
cp -p modules/jaxrpc/target/jbossws-native-jaxrpc-%{version_full}.jar %{buildroot}%{_javadir}/%{name}
cp -p modules/management/target/jbossws-native-management-%{version_full}-sources.jar %{buildroot}%{_javadir}/%{name}
# We cannot install it as an exploded war or maven will not retrieve it
#install -dm 755 %{buildroot}%{_javadir}/%{name}/jbossws-native-management-%{version_full}.war
#cp -p modules/management/target/jbossws-native-management-%{version_full}.war %{buildroot}%{_javadir}/%{name}/jbossws-native-management-%{version_full}.war/
#(cd %{buildroot}%{_javadir}/%{name}/jbossws-native-management-%{version_full}.war; jar xvf jbossws-native-management-%{version_full}.war; rm jbossws-native-management-%{version_full}.war)
cp -p modules/management/target/jbossws-native-management-%{version_full}.war  %{buildroot}%{_javadir}/%{name}
cp -p modules/jaxws-ext/target/jbossws-native-jaxws-ext-%{version_full}-sources.jar %{buildroot}%{_javadir}/%{name}
cp -p modules/jaxws-ext/target/jbossws-native-jaxws-ext-%{version_full}.jar %{buildroot}%{_javadir}/%{name}
cp -p modules/resources/target/jbossws-native-resources-%{version_full}.jar %{buildroot}%{_javadir}/%{name}
cp -p modules/resources/target/jbossws-native-resources-%{version_full}-sources.jar %{buildroot}%{_javadir}/%{name}
cp -p modules/client/target/jbossws-native-client-%{version_full}.jar %{buildroot}%{_javadir}/%{name}
cp -p modules/client/target/jbossws-native-client-%{version_full}-sources.jar %{buildroot}%{_javadir}/%{name}

(cd %{buildroot}%{_javadir}/%{name}
for jar in *-%{version_full}*.jar; do ln -sf ${jar} `echo ${jar} | sed "s|-%{version_full}||g"`;done
for war in *-%{version_full}*.war; do ln -sf ${war} `echo ${war} | sed "s|-%{version_full}||g"`;done)

%add_to_maven_depmap org.jboss.ws.native jbossws-native %{version_full} JPP/%{name} jbossws-native
%add_to_maven_depmap org.jboss.ws.native jbossws-native-jaxws %{version_full} JPP/%{name} jbossws-native-jaxws
%add_to_maven_depmap org.jboss.ws.native jbossws-native-saaj %{version_full} JPP/%{name} jbossws-native-saaj
%add_to_maven_depmap org.jboss.ws.native jbossws-native-core %{version_full} JPP/%{name} jbossws-native-core
%add_to_maven_depmap org.jboss.ws.native jbossws-native-jaxrpc %{version_full} JPP/%{name} jbossws-native-jaxrpc
%add_to_maven_depmap org.jboss.ws.native jbossws-native-management %{version_full} JPP/%{name} jbossws-native-management
%add_to_maven_depmap org.jboss.ws.native jbossws-native-jaxws-ext %{version_full} JPP/%{name} jbossws-native-jaxws-ext
%add_to_maven_depmap org.jboss.ws.native jbossws-native-resources %{version_full} JPP/%{name} jbossws-native-resources
%add_to_maven_depmap org.jboss.ws.native jbossws-native-client %{version_full} JPP/%{name} jbossws-native-client

%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
cp -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native.pom
cp -p modules/jaxws/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native-jaxws.pom
cp -p modules/saaj/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native-saaj.pom
cp -p modules/core/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native-core.pom
cp -p modules/jaxrpc/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native-jaxrpc.pom
cp -p modules/management/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native-management.pom
cp -p modules/jaxws-ext/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native-jaxws-ext.pom
cp -p modules/resources/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native-resources.pom
cp -p modules/client/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native-client.pom

# -repolib
%if %with repolib
# jboss/jbossws
install -d -m 755 %{buildroot}%{repodir}
install -d -m 755 %{buildroot}%{repodirlib}

install -m 755 %{SOURCE1} %{buildroot}%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{release_full}-brew/g' %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml

install -d -m 755 %{buildroot}%{repodirsrc}
install -m 755 %{SOURCE0} %{buildroot}%{repodirsrc}/
install -m 755 %{PATCH0} %{buildroot}%{repodirsrc}/
install -m 755 %{PATCH1} %{buildroot}%{repodirsrc}/
install -m 755 %{PATCH2} %{buildroot}%{repodirsrc}/

cp -p modules/jaxws/target/jbossws-native-jaxws-%{version_full}-sources.jar %{buildroot}%{repodirlib}
cp -p modules/jaxws/target/jbossws-native-jaxws-%{version_full}.jar %{buildroot}%{repodirlib}
cp -p modules/saaj/target/jbossws-native-saaj-%{version_full}-sources.jar %{buildroot}%{repodirlib}
cp -p modules/saaj/target/jbossws-native-saaj-%{version_full}.jar %{buildroot}%{repodirlib}
cp -p modules/core/target/jbossws-native-core-%{version_full}.jar %{buildroot}%{repodirlib}
cp -p modules/core/target/jbossws-native-core-%{version_full}-sources.jar %{buildroot}%{repodirlib}
cp -p modules/jaxrpc/target/jbossws-native-jaxrpc-%{version_full}-sources.jar %{buildroot}%{repodirlib}
cp -p modules/jaxrpc/target/jbossws-native-jaxrpc-%{version_full}.jar %{buildroot}%{repodirlib}
cp -p modules/management/target/jbossws-native-management-%{version_full}-sources.jar %{buildroot}%{repodirlib}
cp -p modules/management/target/jbossws-native-management-%{version_full}.war %{buildroot}%{repodirlib}
cp -p modules/jaxws-ext/target/jbossws-native-jaxws-ext-%{version_full}-sources.jar %{buildroot}%{repodirlib}
cp -p modules/jaxws-ext/target/jbossws-native-jaxws-ext-%{version_full}.jar %{buildroot}%{repodirlib}
cp -p modules/resources/target/jbossws-native-resources-%{version_full}.jar %{buildroot}%{repodirlib}
cp -p modules/resources/target/jbossws-native-resources-%{version_full}-sources.jar %{buildroot}%{repodirlib}
cp -p modules/client/target/jbossws-native-client-%{version_full}.jar %{buildroot}%{repodirlib}
cp -p modules/client/target/jbossws-native-client-%{version_full}-sources.jar %{buildroot}%{repodirlib}

(cd %{buildroot}%{repodirlib}
for jar in *-%{version_full}*.jar; do mv ${jar} `echo ${jar} | sed "s|-%{version_full}||g"`;done
for war in *-%{version_full}*.war; do mv ${war} `echo ${war} | sed "s|-%{version_full}||g"`;done)

cp -p pom.xml %{buildroot}%{repodirlib}/jbossws-native.pom
cp -p modules/jaxws/pom.xml %{buildroot}%{repodirlib}/jbossws-native-jaxws.pom
cp -p modules/saaj/pom.xml %{buildroot}%{repodirlib}/jbossws-native-saaj.pom
cp -p modules/core/pom.xml %{buildroot}%{repodirlib}/jbossws-native-core.pom
cp -p modules/jaxrpc/pom.xml %{buildroot}%{repodirlib}/jbossws-native-jaxrpc.pom
cp -p modules/management/pom.xml %{buildroot}%{repodirlib}/jbossws-native-management.pom
cp -p modules/jaxws-ext/pom.xml %{buildroot}%{repodirlib}/jbossws-native-jaxws-ext.pom
cp -p modules/resources/pom.xml %{buildroot}%{repodirlib}/jbossws-native-resources.pom
cp -p modules/client/pom.xml %{buildroot}%{repodirlib}/jbossws-native-client.pom
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/jbossws-native-client-%{version_full}-sources.jar
%{_javadir}/%{name}/jbossws-native-client-%{version_full}.jar
%{_javadir}/%{name}/jbossws-native-client-sources.jar
%{_javadir}/%{name}/jbossws-native-client.jar
%{_javadir}/%{name}/jbossws-native-core-%{version_full}-sources.jar
%{_javadir}/%{name}/jbossws-native-core-%{version_full}.jar
%{_javadir}/%{name}/jbossws-native-core-sources.jar
%{_javadir}/%{name}/jbossws-native-core.jar
%{_javadir}/%{name}/jbossws-native-jaxrpc-%{version_full}-sources.jar
%{_javadir}/%{name}/jbossws-native-jaxrpc-%{version_full}.jar
%{_javadir}/%{name}/jbossws-native-jaxrpc-sources.jar
%{_javadir}/%{name}/jbossws-native-jaxrpc.jar
%{_javadir}/%{name}/jbossws-native-jaxws-%{version_full}-sources.jar
%{_javadir}/%{name}/jbossws-native-jaxws-%{version_full}.jar
%{_javadir}/%{name}/jbossws-native-jaxws-ext-%{version_full}-sources.jar
%{_javadir}/%{name}/jbossws-native-jaxws-ext-%{version_full}.jar
%{_javadir}/%{name}/jbossws-native-jaxws-ext-sources.jar
%{_javadir}/%{name}/jbossws-native-jaxws-ext.jar
%{_javadir}/%{name}/jbossws-native-jaxws-sources.jar
%{_javadir}/%{name}/jbossws-native-jaxws.jar
%{_javadir}/%{name}/jbossws-native-management-%{version_full}-sources.jar
%{_javadir}/%{name}/jbossws-native-management-%{version_full}.war
%{_javadir}/%{name}/jbossws-native-management-sources.jar
%{_javadir}/%{name}/jbossws-native-management.war
%{_javadir}/%{name}/jbossws-native-resources-%{version_full}-sources.jar
%{_javadir}/%{name}/jbossws-native-resources-%{version_full}.jar
%{_javadir}/%{name}/jbossws-native-resources-sources.jar
%{_javadir}/%{name}/jbossws-native-resources.jar
%{_javadir}/%{name}/jbossws-native-saaj-%{version_full}-sources.jar
%{_javadir}/%{name}/jbossws-native-saaj-%{version_full}.jar
%{_javadir}/%{name}/jbossws-native-saaj-sources.jar
%{_javadir}/%{name}/jbossws-native-saaj.jar
%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native-client.pom
%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native-core.pom
%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native-jaxrpc.pom
%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native-jaxws-ext.pom
%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native-jaxws.pom
%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native-management.pom
%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native-resources.pom
%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native-saaj.pom
%{_datadir}/maven2/poms/JPP.%{name}-jbossws-native.pom
%{_mavendepmapfragdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Tue Sep 21 2010 David Walluck <dwalluck@redhat.com> 1:3.1.2-1.SP1.4
- use jboss-common-core and jbossxb2

* Wed Mar 10 2010 David Walluck <dwalluck@redhat.com> 1:3.1.2-1.SP1.3
- fix version in depmap entries

* Tue Mar 09 2010 David Walluck <dwalluck@redhat.com> 1:3.1.2-1.SP1.2
- bump Epoch to 1 to override jbossws-native

* Wed Nov 25 2009 David Walluck <dwalluck@redhat.com> 0:3.1.2-1.SP1.1
- 3.1.2.SP1
